﻿#target illustrator 

//子フォルダ名　ここから
var fname =[
   'デザイン',
    '入稿',
    '業務資料',
    '見積',
    '依頼書',
];
//子フォルダ名　ここまで

//メイン処理　ここから
var saveFolder = Folder.selectDialog ('フォルダの作成場所を選んでください');

if(saveFolder){
    var decode =  decodeURIComponent(saveFolder);//文字化け対策
    var folderName = prompt ('フォルダ名を入力してください','','フォルダ');
    createFolder(folderName,saveFolder,decode);//フォルダーを作成する関数
} else {
    alert ('フォルダーを作成できませんでした。');
}
//メイン処理　ここまで

function createFolder(folderName,saveFolder,decode){
    var parentFolder = new Folder(saveFolder + "/" + folderName); // Folderオブジェクトに変換  
    if(parentFolder.exists){   //もし同名のフォルダが存在しなければ、新しいフォルダーを作成する　　.exists：特定のファイルやフォルダが存在するかどうかを確認
        var choice = prompt("同名のフォルダが既に存在します。次の処理のうちどれを選びますか？\n1. フォルダを上書きする\n2. フォルダ名の最後に（1）を追加する", "", "選択してください");
        switch(choice) {//プログラムが複数の条件から一つを選択する必要がある場合
            case "1":
                removeAll(parentFolder);//フォルダ内のデータを削除
                parentFolder.remove(); // フォルダを削除してから再作成
                fcreate(parentFolder);//フォルダーを作成する関数
                break;//処理を抜ける
            case "2":
                var i = 1;
                while (new Folder(saveFolder + "/" + folderName + "(" + i + ")").exists) {//同名のフォルダがある限り繰り返す
                    i++;
                }
                folderName += "(" + i + ")"; // フォルダ名の最後に（i）を追加
                parentFolder = new Folder(saveFolder + "/" + folderName);
                fcreate(parentFolder);
                break;    //処理を抜ける           
            default:    //条件と一致しない場合
                alert("処理を中止します。");
                break; //処理を抜ける
        }        
    }else {
        fcreate(parentFolder)
    }
    alert('［ ' + decode + ' ］' + " にフォルダを作成しました");
}

function fcreate(create){
    //親フォルダ作成　ここから
    var folder = new Folder (create);//フォルダオブジェクトのインスタンス化
    folder.create();　//.フォルダ作成　crete：作成する
    //親フォルダ作成　ここまで
    //子フォルダ作成　ここから
    for(var i = 0 ; i < fname.length; i++){    
            var suri = ("00" + [i]).slice( -2 ); //ファイル№の桁数をそろえる
            var subFolder = create + "/" + suri + '_' + fname[i];//作成するフォルダのパスと名称
            var sub = new Folder(subFolder);
            sub.create();
     }
    //子フォルダ作成　ここまで
}

function removeAll(folderObj) {
    var files = folderObj.getFiles();//フォルダ内ファイルを取得する
    for (var i = 0; i < files.length; i++) {ファイルの数だけ繰り返す
        if (files[i] instanceof File) {　//files[i]がFileのインスタンスであるかどうかをチェック
            files[i].remove();//削除する
        } else {
            removeAll(files[i]); // 再帰的にサブフォルダ内のファイルを削除
            files[i].remove(); // サブフォルダを削除
        }
    }
}

/*
 このスクリプトのフローチャートは以下のようになります：


開始
  |
  ↓
フォルダの作成場所を選択
  |
  ↓
選択した場所が存在するか？
  |          |
  | はい     | いいえ
  ↓          ↓
フォルダ名を入力    フォルダを作成できませんでした（アラート）
  |
  ↓
同名の親フォルダが存在するか？
  |          |
  | はい     | いいえ
  ↓          ↓
同名のフォルダが既に存在します（アラート）    親フォルダを作成
                            |
                            ↓
                        各子フォルダについてループ
                            |
                            ↓
                    同名の子フォルダが存在するか？
                      |          |
                      | はい     | いいえ
                      ↓          ↓
            同名のサブフォルダが既に存在します（アラート）    子フォルダを作成
                            |
                            ↓
                  フォルダを作成しました（アラート）
                            |
                            ↓
                          終了
```
*/